<?php namespace Engine;

use Engine\Events\Event;
use Engine\Job\Publish\Publish;

class Engine
{

    /**
     * @var array
     */
    private $jobs = [];

    public function __construct()
    {

    }

    public function addJob(/* Polymorphic */ $job)
    {
        $this->jobs[] = $job;
    }

    public function run(\Illuminate\Support\Facades\Log $logger = null)
    {

        Event::fire('engine.started');
        foreach ($this->getJobs() as $job)
        {
            //if( $job instanceof Publish)
            $job->run($logger);
        }
        Event::fire('engine.end');

    }

    public function getJobs()
    {
        return $this->jobs;
    }

    public static function existIn($paths, $filename)
    {
        $in = false;
        foreach ($paths as $path)
        {
            if( file_exists($path . DIRECTORY_SEPARATOR . $filename) )
            {
                $in = $path . DIRECTORY_SEPARATOR . $filename;
            }
        }

        return $in;
    }

    public static function paths($accountToken, $prefix, \DateTime $registerDate)
    {
        $year = $registerDate->format('Y');
        $month = $registerDate->format('m');
        $day = $registerDate->format('d');

        $temp = [];

        // Build the path to the file
        $path = $prefix . DIRECTORY_SEPARATOR . $accountToken;
        $temp[] = $path;
        $temp[] = implode(DIRECTORY_SEPARATOR, [$path, $year, $month, $day]);

        return $temp;
    }

}