<?php namespace Engine\Job\Publish\Handlers\Couch\DesignDocuments;

class ChannelsComposedVideo implements \Doctrine\CouchDB\View\DesignDocument
{
    private $orderBy;
    private $viewName;

    public function __construct($viewName = 'channels_composed_videos', $orderBy = 'doc.publish_at')
    {
        $this->orderBy = $orderBy;
        $this->viewName = $viewName;
        if( $this->orderBy == "doc.data.duration" )
            $this->orderBy = "parseFloat(". $this->orderBy .")";
    }

    public function getData()
    {
        return array(
            'language' => 'javascript',
            'views' => array(
                $this->viewName => array(
                    'map' => 'function(doc) {
                        if(\'composed\' == doc.type && doc.on.length) {
                           for ( var i=0 ; i <= 0; i++ ){/* doc.on.length - 1 */
                            emit([doc.on[i][0], ' . $this->orderBy . '], doc);
                          }
                        }
                    }',
                    "reduce" => "_count"
                ),
            ),
        );
    }
}