<?php namespace Engine\Job\Publish\Handlers\Couch\DesignDocuments;

class ChannelsPlaylists implements \Doctrine\CouchDB\View\DesignDocument
{
    private $orderBy;
    private $viewName;

    public function __construct($viewName = 'channels_playlists', $orderBy = 'doc.data.date.publish')
    {
        $this->orderBy = $orderBy;
        $this->viewName = $viewName;
    }

    public function getData()
    {
        return array(
            'language' => 'javascript',
            'views' => array(
                $this->viewName => array(
                    'map' => 'function(doc) {
                        if(\'playlist\' == doc.type) {
                          for ( var i=0 ; i <= doc.on.length - 1; i++ ){
                            emit([doc.on[i][0],doc.publish_at], doc); 
                          }
                        }
                    }',
                    "reduce" => "_count"
                ),
            ),
        );
    }
}