<?php namespace Engine\Job\Publish\Handlers\Couch\DesignDocuments;

class ChannelsPlaylistsByIsoByTag implements \Doctrine\CouchDB\View\DesignDocument
{
    public function getData()
    {
        return array(
            'language' => 'javascript',
            'views' => array(
                'channels_playlists_by_iso_by_tag' => array(
                    'map' => 'function(doc) {
                        if(\'playlist\' == doc.type) {
                           for ( var k=0 ; k <= doc.on.length - 1; k++ ){
                             channel = doc.on[k][0];
                              position = doc.on[k][1];
                              if( doc.data.l10n.length ) {
                                for ( var j=0 ; j <= doc.data.l10n.length - 1; j++ ){
                                    iso = doc.data.l10n[j][\'isoLanguage\'];
                                    if( doc.data.l10n[j][\'tags\'].length ) {          
                                      for ( var i=0 ; i <= doc.data.l10n[j][\'tags\'].length - 1; i++ ){
                                      l10n = doc.data.l10n.filter(function(item){
                                        return item.isoLanguage == doc.data.l10n[j][\'isoLanguage\'];
                                      });
                                    
                                       tags = doc.tags.filter(function(item){
                                          return item.isoLanguage == doc.data.l10n[j][\'isoLanguage\'];
                                       });
                                       
                                      obj = {
                                            _id: doc._id,
                                            _rev: doc._rev,
                                            id: doc.data.id,
                                            begin_at: doc.begin_at,
                                            created_at: doc.created_at,
                                            data: {
                                              id: doc.data.id,
                                              l10n: l10n.length ? l10n[0] : {},
                                              name: doc.data.name,
                                              /*managementName: doc.data.managementName,*/
                                              random: doc.data.random,
                                              date: {
                                                begin: doc.data.date.begin,
                                                end: doc.data.date.end,
                                                publish: doc.data.date.publish,
                                                register: doc.data.date.register
                                              },
                                              videos: {
                                                count: doc.data.videos.count
                                              }
                                            }, 
                                            end_at: doc.end_at,
                                            publish_at: doc.publish_at,
                                            id: doc.id,
                                            on: doc.on,
                                            tags: tags.length ? tags[0][\'list\'] : {},
                                            type: doc.type,
                                            updated_at: doc.updated_at
                                           };
                                        tag = doc.data.l10n[j].tags[i][\'slug\'];                                        
                                        emit([channel, iso, tag, position], obj)
                                      }
                                    } 
                                  }
                                }
                              }
                            }
                    }',
                    "reduce" => "_count"
                ),
            ),
        );
    }
}