<?php namespace Engine\Job\Publish\Handlers\Couch\DesignDocuments;

class ChannelsPlaylistsIdByIso implements \Doctrine\CouchDB\View\DesignDocument
{
    public function getData()
    {
        return array(
            'language' => 'javascript',
            'views' => array(
                'channels_playlists_id_by_iso' => array(
                    'map' => 'function(doc) {
                        if(\'playlist\' == doc.type) {
                          for ( var i=0 ; i <= doc.on.length - 1; i++ ){
                            for ( var j=0 ; j <= doc.data.l10n.length - 1; j++ ){
                              
                              l10n = doc.data.l10n.filter(function(item){
                                return item.isoLanguage == doc.data.l10n[j][\'isoLanguage\'];
                              });
                            
                              obj = {
                                id: doc.data.id,
                                l10n: l10n.length ? l10n[0] : {},
                                name: doc.data.name,
                                /*managementName: doc.data.managementName,*/
                                random: doc.data.random,
                                date: {
                                  begin: doc.data.date.begin,
                                  end: doc.data.date.end
                                },
                                videos: {
                                  count: doc.data.videos.count
                                }
                              };
                            
                              emit([doc.on[i][0],doc.id, doc.data.l10n[j][\'isoLanguage\'], doc.created_at], obj);
                            }                             
                          }
                        }
                    }',
                    "reduce" => "_count"
                ),
            ),
        );
    }
}