<?php namespace Engine\Job\Publish\Handlers\Couch\DesignDocuments;

class CollectionLatestPosts implements \Doctrine\CouchDB\View\DesignDocument
{
    public function getData()
    {
        return array(
            'language' => 'javascript',
            'views' => array(
                'collections_latest' => array(
                    'map' => 'function(doc) {
                        if(\'post\' == doc.type) {
                          for ( var j=0 ; j <= doc.on.length - 1; j++ ){
                            for ( var k=0 ; k <= doc.iso.length - 1; k++ ){
                            
                              var foundAt = [];
                              var removeAt = [];
                        
                              for(var i = 0; i <= doc.data.l10n.length - 1; i++) {	  
                                if(doc.data.l10n[i].iso != doc.iso[k]) {
                                  removeAt.push(i);        
                                 } else if ( doc.data.l10n[i].iso == doc.iso[k] ) {
                                  foundAt.push(i);     	
                                 }
                              }
                        
                              var obj = {
                                "_id": doc._id,
                                "_rev": doc._rev,
                                "id": doc.id,
                                "on": doc.on,
                                "iso": doc.iso,
                                "type": doc.type,
                                "dossiers": doc.dossiers,
                                "created_at": doc.created_at,
                                "updated_at": doc.updated_at,
                                "data": { "l10n": doc.data.l10n[foundAt] }};
                            
                              var sortBy = doc.data.l10n[foundAt].date.publish;
                              emit([doc.on[j][0]].concat(doc.iso[k]).concat(sortBy), obj);
                            }
                          }
                        }
                    }',
                    "reduce" => "_count"
                ),
            ),
        );
    }
}