<?php namespace Engine\Job\Publish\Handlers\Couch\DesignDocuments;

class CollectionsDossiersPostBySlug implements \Doctrine\CouchDB\View\DesignDocument
{
    public function getData()
    {
        return array(
            'language' => 'javascript',
            'views' => array(
                'collections_dossiers_post_by_slug' => array(
                    'map' => 'function(doc) {
                        if(\'post\' == doc.type) {
                           for ( var k=0 ; k <= doc.iso.length - 1; k++ ) {
                           
                              var foundAt = [];
                              var removeAt = [];
                        
                              for(var i = 0; i <= doc.data.l10n.length - 1; i++) {	  
                                if(doc.data.l10n[i].iso != doc.iso[k]) {
                                  removeAt.push(i);        
                                 } else if ( doc.data.l10n[i].iso == doc.iso[k] ) {
                                  foundAt.push(i);     	
                                 }
                              }

                              var obj = {
                                "_id": doc._id,
                                "_rev": doc._rev,
                                "id": doc.id,
                                "on": doc.on,
                                "iso": doc.iso,
                                "type": doc.type,
                                "dossiers": doc.dossiers,
                                "created_at": doc.created_at,
                                "updated_at": doc.updated_at,
                                "data": { "l10n": doc.data.l10n[foundAt] }};

                              var slug = doc.data.l10n[foundAt].metadata.slug;
                              emit([slug,doc.iso[k]].concat(doc.created_at), obj);
                            }
                        }
                    }'
                ),
            ),
        );
    }
}