<?php namespace Engine\Job\Publish\Handlers\Couch\DesignDocuments;

class ComposedVideos implements \Doctrine\CouchDB\View\DesignDocument
{
    private $orderBy;
    private $viewName;

    public function __construct($viewName = 'channels_composed_videos_by_iso', $orderBy = 'date')
    {
        $this->orderBy = $orderBy;
        $this->viewName = $viewName;
        if( $this->orderBy == "duration" )
            $this->orderBy = "parseFloat(". $this->orderBy .")";
    }

    public function getData()
    {
        return array(
            'language' => 'javascript',
            'views' => array(
                $this->viewName => array(
                    'map' => 'function(doc) {
                        if(\'composed\' == doc.type && doc.on.length) {
                        for ( var i=0 ; i <= 0; i++ ){ /* doc.on.length - 1 */
                            
                                obj = {
                                _id: doc._id,
                                _rev: doc._rev,
                                begin_at: doc.begin_at,
                                created_at: doc.created_at,
                                data: {
                                  id: doc.data.id,
                                  name: doc.data.name,
                                  duration: doc.data.duration,
                                  autoplay: doc.data.autoplay,
                                  hasInsideSocial: doc.data.hasInsideSocial,
                                  playInline: doc.data.playInline,
                                  playMark: doc.data.playMark,
                                  profile: doc.data.profile,
                                  thumbnail: doc.data.thumbnail,
                                  playlists: doc.data.playlists,
                                  labels: doc.data.labels,
                                  date: doc.data.date,       
                               },
                                  id: doc.data.id,
                                  end_at: doc.end_at,
                                  is_live: doc.is_live,
                                  on: doc.on,
                                  publish_at: doc.publish_at,
                                  type: doc.type,
                                  updated_at: doc.updated_at,
                                  video: doc.video                                                               
                                 };
                                                                
                                 date = doc.data.date.publish;                                                                  
                                 duration = doc.data[\'duration\'];
                                 emit([' . $this->orderBy . '], obj);                         
                       }
                      }
                    }',
                    "reduce" => "_count"
                ),
            ),
        );
    }
}