<?php namespace Engine\Job\Publish\Handlers\Couch\DesignDocuments;

class ComposedVideosByIso implements \Doctrine\CouchDB\View\DesignDocument
{
    private $orderBy;
    private $viewName;

    public function __construct($viewName = 'channels_composed_videos_by_iso', $orderBy = 'date')
    {
        $this->orderBy = $orderBy;
        $this->viewName = $viewName;
        if( $this->orderBy == "duration" )
            $this->orderBy = "parseFloat(". $this->orderBy .")";
    }

    public function getData()
    {
        return array(
            'language' => 'javascript',
            'views' => array(
                $this->viewName => array(
                    'map' => 'function(doc) {
                        if(\'composed\' == doc.type && doc.on.length) {
                        for ( var i=0 ; i <= 0; i++ ){/* doc.on.length - 1 */
                          for ( var j=0 ; j <= doc.data.profile.l10n.length - 1; j++ ){
                            l10n = doc.data.profile.l10n.filter(function(item){
                              return item.isoLanguage == doc.data.profile.l10n[j][\'isoLanguage\'];
                            });
                            
                            /*for( var k = 0 ; k <= doc.data.profile.l10n[j].tags.length - 1; k++ ){*/  
                            
                                
                                obj = {
                                _id: doc._id,
                            _rev: doc._rev,
                            begin_at: doc.begin_at,
                            created_at: doc.created_at,
                            data: {
                                  id: doc.data.id,
                              name: doc.data.name,
                                  duration: doc.data.duration,
                                  autoplay: doc.data.autoplay,
                                  hasInsideSocial: doc.data.hasInsideSocial,
                                  playInline: doc.data.playInline,
                                  playMark: doc.data.playMark,
                                  profile: l10n.length ? {l10n: l10n[0] } : {},
                                  thumbnail: doc.data.thumbnail,
                                  playlists: doc.data.playlists,
                                  labels: doc.data.labels,
                                  date: doc.data.date,       
                               },
                                  id: doc.data.id,
                                  end_at: doc.end_at,
                                  is_live: doc.is_live,
                                  on: doc.on,
                                  publish_at: doc.publish_at,
                                  type: doc.type,
                                  updated_at: doc.updated_at,
                                  video: doc.video                                                               
                                 };
                                                            
                                 /* [ idChannel, iso, date] */
                                 iso = doc.data.profile.l10n[j][\'isoLanguage\'];
                                 date = doc.data.date.publish;
                                 /*tag = doc.data.profile.l10n[j].tags[k][\'slug\'];*/
                                 title = doc.data.profile.l10n[j][\'title\'];
                                 duration = doc.data[\'duration\'];
                                 emit([iso, ' . $this->orderBy . '], obj);
                           /*}*/
                         }
                       }
                      }
                    }',
                    "reduce" => "_count"
                ),
            ),
        );
    }
}