<?php namespace Engine\Job\Publish\Handlers\Couch\DesignDocuments;

class ComposedVideosByStickersByIsoByPosition implements \Doctrine\CouchDB\View\DesignDocument
{
    private $orderBy;
    private $viewName;

    public function __construct($viewName = 'latest', $orderBy = 'doc.publish_at')
    {
        $this->orderBy = $orderBy;
        $this->viewName = $viewName;
    }

    public function getData()
    {
        return array(
            'language' => 'javascript',
            'views' => array(
                $this->viewName => array(
                    'map' => 'function(doc) {
                        if(\'composed\' == doc.type && doc.on.length) {
                          for ( var i=0 ; i <= 0; i++ ){/* doc.on.length - 1 */
                            for ( var k=0 ; k <= doc.data.stickers.length - 1; k++ ){
                              for ( var j=0 ; j <= doc.data.profile.l10n.length - 1; j++ ){
                                l10n = doc.data.profile.l10n.filter(function(item){
                                  return item.isoLanguage == doc.data.profile.l10n[j][\'isoLanguage\'];
                                });
                            
                                obj = {
                                _id: doc._id,
                                _rev: doc._rev,
                                begin_at: doc.begin_at,
                                created_at: doc.created_at,
                                data: {
                                   id: doc.data.id,
                                   name: doc.data.name,
                                   duration: doc.data.duration,
                                   autoplay: doc.data.autoplay,
                                   hasInsideSocial: doc.data.hasInsideSocial,
                                   playInline: doc.data.playInline,
                                   playMark: doc.data.playMark,
                                   profile: l10n.length ? {l10n: l10n[0] } : {},
                                   thumbnail: doc.data.thumbnail,
                                   playlists: doc.data.playlists,
                                   labels: doc.data.labels,
                                   stickers: doc.data.stickers,
                                   date: doc.data.date,       
                                 },
                                 id: doc.data.id,
                                 end_at: doc.end_at,
                                 is_live: doc.is_live,
                                 on: doc.on,
                                 publish_at: doc.publish_at,
                                 type: doc.type,
                                 updated_at: doc.updated_at,
                                 video: doc.video                                                               
                                };
                                                                   
                                iso = doc.data.profile.l10n[j][\'isoLanguage\'];
                                date = doc.data.date.publish;
                                emit([doc.data.stickers[k][\'slug\'], iso, doc.data.stickers[i][\'position\']], obj);

                              }                                    
                            }
                          }
                        }
                    }',
                    'reduce' => "_count"
                ),
            ),
        );
    }
}