<?php namespace Engine\Job\Publish\Handlers\Couch\DesignDocuments;

class ComposedVideosByStickersByPosition implements \Doctrine\CouchDB\View\DesignDocument
{
    private $orderBy;
    private $viewName;

    public function __construct($viewName = 'latest', $orderBy = 'doc.publish_at')
    {
        $this->orderBy = $orderBy;
        $this->viewName = $viewName;
    }

    public function getData()
    {
        return array(
            'language' => 'javascript',
            'views' => array(
                $this->viewName => array(
                    'map' => 'function(doc) {
                        if(\'composed\' == doc.type && doc.on.length) {
                          for ( var i=0 ; i <= doc.data.stickers.length - 1; i++ ){
                            for ( var j=0 ; j <= 0; j++ ){/* doc.on.length - 1 */
                              emit([doc.data.stickers[i][\'slug\'], doc.data.stickers[i][\'position\']], doc);
                            }
                          }
                        }
                    }',
                    'reduce' => "_count"
                ),
            ),
        );
    }
}