<?php namespace Engine\Job\Publish\Handlers\Couch\DesignDocuments;

class LatestComposedVideoByChannelTag implements \Doctrine\CouchDB\View\DesignDocument
{
    private $orderBy;
    private $viewName;

    public function __construct($viewName = 'channels_composed_videos_by_iso', $orderBy = 'date')
    {
        $this->orderBy = $orderBy;
        $this->viewName = $viewName;
        if( $this->orderBy == "duration" )
            $this->orderBy = "parseFloat(". $this->orderBy .")";
    }

    public function getData()
    {
        return array(
            'language' => 'javascript',
            'views' => array(
                $this->viewName => array(
                    'map' => 'function(doc) {
                        if(\'composed\' == doc.type && doc.data.duration != null) {
                        for ( var i=0 ; i <= 0; i++ ){ /* doc.on.length - 1 */
                          for ( var k=0 ; k <= doc.channel_tags.length - 1; k++ ){                            
                            for ( var m=0 ; m <= doc.channel_tags[k].length - 1; m++ ){
                                                                                           
                              obj = {
                                _id: doc._id,
                                _rev: doc._rev,
                                begin_at: doc.begin_at,
                                created_at: doc.created_at,
                                data: {
                                  id: doc.data.id,
                                  name: doc.data.name,
                                  duration: doc.data.duration,
                                  autoplay: doc.data.autoplay,
                                  hasInsideSocial: doc.data.hasInsideSocial,
                                  playInline: doc.data.playInline,
                                  playMark: doc.data.playMark,
                                  profile: doc.data.profile,
                                  thumbnail: doc.data.thumbnail,
                                  playlists: doc.data.playlists,
                                  labels: doc.data.labels,
                                  date: doc.data.date,       
                               },
                                  id: doc.data.id,
                                  end_at: doc.end_at,
                                  is_live: doc.is_live,
                                  on: doc.on,
                                  publish_at: doc.publish_at,
                                  type: doc.type,
                                  updated_at: doc.updated_at,
                                  video: doc.video                                                               
                                 };
                                                                                             
                                 /*iso = doc.data.profile.l10n[j][\'isoLanguage\'];*/
                                 date = doc.data.date.publish;
                                 tag = doc.channel_tags[k][m][\'slug\'];                                 
                                 duration = doc.data[\'duration\'];
                                 emit([tag, ' . $this->orderBy . '], obj);                                                     
                            }
                         }
                       }
                      }
                    }',
                    "reduce" => "_count"
                ),
            ),
        );
    }
}