<?php namespace Engine\Job\Publish\Handlers\Couch\DesignDocuments;

class LatestVideos implements \Doctrine\CouchDB\View\DesignDocument
{
    private $orderBy;
    private $viewName;

    public function __construct($viewName = 'latest', $orderBy = 'doc.publish_at')
    {
        $this->orderBy = $orderBy;
        $this->viewName = $viewName;
        if( $this->orderBy == "doc.data.duration" )
            $this->orderBy = "parseFloat(". $this->orderBy .")";
    }

    public function getData()
    {
        return array(
            'language' => 'javascript',
            'views' => array(
                $this->viewName => array(
                    'map' => 'function(doc) {
                        if(\'composed\' == doc.type && doc.data.duration != null) {
                          for ( var i=0 ; i <= 0; i++ ){ /* doc.on.length - 1 */
                            for ( var k=0 ; k <= doc.data.profile.l10n.length - 1; k++ ){
                              emit([doc.on[i][0],' . $this->orderBy . ' ], doc);
                            }
                          }
                        }
                    }',
                    'reduce' => "_count"
                ),
            ),
        );
    }
}