<?php namespace Engine\Job\Publish\Handlers\Couch\DesignDocuments;

class LatestVideosByIso implements \Doctrine\CouchDB\View\DesignDocument
{
    private $orderBy;
    private $viewName;

    public function __construct($viewName = 'latest_by_iso', $orderBy = 'date')
    {
        $this->orderBy = $orderBy;
        $this->viewName = $viewName;
    }

    public function getData()
    {
        return array(
            'language' => 'javascript',
            'views' => array(
                $this->viewName => array(
                    'map' => 'function(doc) {
                        if(\'composed\' == doc.type && doc.data.duration != null) {
                          for ( var i=0 ; i <= 0; i++ ){ /* doc.on.length - 1 */
                            for ( var k=0 ; k <= doc.data.profile.l10n.length - 1; k++ ){
                              l10n = doc.data.profile.l10n.filter(function(item){
                                      return item.isoLanguage == doc.data.profile.l10n[k][\'isoLanguage\'];
                                    });
                            
                                obj = {
                                  id: doc.data.id,
                                  name: doc.data.name,
                                  duration: doc.data.duration,
                                  autoplay: doc.data.autoplay,
                                  hasInsideSocial: doc.data.hasInsideSocial,
                                  playInline: doc.data.playInline,
                                  playMark: doc.data.playMark,
                                  profile: l10n.length ? {l10n: l10n[0] } : {},
                                  thumbnail: doc.data.thumbnail,
                                  playlists: doc.data.playlists,
                                  date: doc.data.date,                                 
                                };
                                    
                                iso = doc.data.profile.l10n[k][\'isoLanguage\'];
                                date = doc.data.date.publish;
                                emit([doc.on[i][0], iso, ' . $this->orderBy . '], obj);
                            }
                          }
                        }
                    }',
                    'reduce' => "_count"
                ),
            ),
        );
    }
}