<?php namespace Engine\Job\Publish\Handlers\Couch\DesignDocuments;

class LivesChannelByTag implements \Doctrine\CouchDB\View\DesignDocument
{
    private $orderBy;
    private $viewName;

    public function __construct($viewName = 'latest', $orderBy = 'doc.publish_at')
    {
        $this->orderBy = $orderBy;
        $this->viewName = $viewName;
    }

    public function getData()
    {
        return array(
            'language' => 'javascript',
            'views' => array(
                $this->viewName => array(
                    'map' => 'function(doc) {
                        if(\'composed\' == doc.type && doc.data.duration === null && doc.on.length ) {
                          for ( var i=0 ; i <= doc.channel_tags.length - 1; i++ ){
                            for ( var j=0 ; j <= doc.channel_tags[i].length - 1; j++ ){
                              emit([doc.channel_tags[i][j][\'slug\'], doc.publish_at], doc);
                            }
                          }
                        }
                    }',
                    'reduce' => "_count"
                ),
            ),
        );
    }
}