<?php namespace Engine\Job\Publish\Handlers\Couch\DesignDocuments;

class SimpleComposedVideoByIso implements \Doctrine\CouchDB\View\DesignDocument
{
    public function getData()
    {
        return array(
            'language' => 'javascript',
            'views' => array(
                'simple_composed_video_by_iso' => array(
                    'map' => 'function(doc) {
                        if(\'composed\' == doc.type && doc.on.length) {
                           for ( var j=0 ; j <= doc.data.profile.l10n.length - 1; j++ ){
                             l10n = doc.data.profile.l10n.filter(function(item){
                               return item.isoLanguage == doc.data.profile.l10n[j][\'isoLanguage\'];
                             });
                                
                             obj = {
				                  _id: doc._id,
                                   _rev: doc._rev,
				                data: {
                                  id: doc.data.id,
                                  name: doc.data.name,
                                  duration: doc.data.duration,
                                  autoplay: doc.data.autoplay,
                                  hasInsideSocial: doc.data.hasInsideSocial,
                                  playInline: doc.data.playInline,
                                  playMark: doc.data.playMark,
                                  profile: l10n.length ? {l10n: l10n[0] } : {},
                                  thumbnail: doc.data.thumbnail,
                                  playlists: doc.data.playlists,
                                  date: doc.data.date,                                  
                                  },
                                  id: doc.id,
                                  stream:doc.stream,
				                  video: doc.video,
                                  is_live: doc.is_live,
                                  publish_at: doc.publish_at,
                                  begin_at: doc.begin_at,
                                  end_at: doc.end_at,
                                  created_at: doc.created_at,
                                  updated_at: doc.updated_at, 
                                  sources: doc.sources                               
                                };      
                             iso = doc.data.profile.l10n[j][\'isoLanguage\'];
                             date = doc.data.date.publish; 
                             emit([doc.id, iso, date], obj);         
                           }                           
                        }
                    }'
                ),
            ),
        );
    }
}