<?php namespace Engine\Job\Publish\Handlers\Couch\DesignDocuments;

class Videos implements \Doctrine\CouchDB\View\DesignDocument
{
    private $orderBy;
    private $viewName;

    public function __construct($viewName = 'latest', $orderBy = 'doc.publish_at')
    {
        $this->orderBy = $orderBy;
        $this->viewName = $viewName;
    }

    public function getData()
    {
        return array(
            'language' => 'javascript',
            'views' => array(
                $this->viewName => array(
                    'map' => 'function(doc) {
                        if(\'composed\' == doc.type) {                          
                            emit([doc.publish_at], doc);
                        }
                    }',
                    'reduce' => "_count"
                ),
            ),
        );
    }
}