<?php namespace Engine\Job\Publish\Services\Videos\Schemas;

use DateTime;

class SchemaHelper {

    public static function innerTags($tags)
    {
        return array_map(function($tag){

            $temp = $tag->toArray();
            $temp['count'] = (int) $temp['total'];
            $temp['slug'] = $temp['nameStripped'];
            // $temp['date'] = ['register' => (new DateTime($tag['register_date']))->format($format)];

            unset($temp['nameStripped']);
            unset($temp['total']);
            unset($temp['public']);
            unset($temp['totalProfile']);
            unset($temp['totalLiveProfile']);
            return $temp;
        }, $tags);
    }

    public static function outterTags($isos, $function, $method, $parameters, $format)
    {
        $data = [];
        foreach ($isos as $iso)
        {
            // Set the Tags
            $tags = array_map(function ($tag) use ($iso, $format) {

                return [
                    'id' => (int) $tag['id_tag'],
                    'name' => $tag['name'],
                    'slug' => $tag['name_stripped'],
                    'date' => ['register' => (new DateTime($tag['register_date']))->format($format)],
                    // 'playlist' => ['id' => (int) $tag['id_playlist']],    // Id playlist
                    'videos' => ['count' => (int) $tag['total']],   // Total number of composed videos
                ];

            }, call_user_func_array([$function, $method], [$parameters, $iso]));

            // \Engine\Job\Publish\Support\Video::channelTags($idChannel, $iso)
            //call_user_func_array(['\Engine\Job\Publish\Support\Video','channelTags'], [$idChannel, $iso]);

            array_push($data, ['isoLanguage' => $iso, 'list' => $tags]);

        }

        return $data;
    }

}