<?php namespace Engine\Job\Publish\Support;

use Exception;
use PDO;
use Stage\Stage;

class Asset
{

    /**
     * assetsAlbumsTags
     *
     * Return all the tags inside an Album
     * @param $idAlbum
     * @return array
     * @throws Exception
     */
    public static function assetsAlbumsTags($idAlbum)
    {
        try {

            $name = "PUBLISH_ASSETS_ALBUMS_TAGS";
            $method = "GET";
            $parameters = [[$idAlbum, PDO::PARAM_INT]];

            $data = Stage::esp($parameters, $name, $method);
            return $data;

        } catch(Exception $e){
            throw $e;
        }
    }

    /**
     * assetsGalleriesTags
     *
     * Return all the Tags inside a gallery
     * @param $idGallery
     * @return array
     * @throws Exception
     */
    public static function assetsGalleriesTags($idGallery)
    {
        try {

            $name = "PUBLISH_ASSETS_TAGS";
            $method = "GET";
            $parameters = [[$idGallery, PDO::PARAM_INT]];

            $data = Stage::esp($parameters, $name, $method);
            return $data;

        } catch(Exception $e){
            throw $e;
        }
    }

}